VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Party"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Reprsentation einer beteiligten Partei

Private Transmission As NoKeyTransmission    ' Unsere Transmission

Private Key    As Long                       ' Der Schlssel, den wir haben wollen
Private Exp    As Long                       ' Unsere Primzahl
Private Exp2   As Long                       ' Ihr Inverses

Public Event GotMessage(ByVal Message As String)

' Initialisieren
Public Sub Initialize(ByVal Tr As NoKeyTransmission)
   Call Randomize
   
   Set Transmission = Tr
   
   Exp = CoPrime(Transmission.Modul - 1)        ' Exponenten festlegen
   Exp2 = EuklidEx(Exp, Transmission.Modul - 1) ' Entschlsselungsexponenten festlegen
End Sub

' Verschlsseln
Public Function Encrypt(ByVal Data As Long) As Long
   Encrypt = ModExp(Data, Exp, Transmission.Modul)
End Function

' Entschlsseln
Public Function Decrypt(ByVal Data As Long) As Long
   Decrypt = ModExp(Data, Exp2, Transmission.Modul)
End Function

' Setzen
Public Function SetKey(c3 As Long)
   Key = Decrypt(c3)
   
   Call Form1.List3.AddItem("[c4] = " & CStr(Key))
   Call Form1.List3.AddItem("")
End Function

' Schlssel vereinbaren
Public Function ArrangeKey(Value As Long)
   Key = Value
   
   Call Form1.List3.AddItem("[k] = " & CStr(Key))
   
   Call Transmission.Arrange(Value)
End Function

' Text versenden
Public Sub Submit(ByVal Text As String, ByVal Dest As Party)
   Dim Bytes() As Byte
   
   Bytes = StrConv(Text, vbFromUnicode)
   
   ' Mit dem Schlssel verschlsseln
   Call EncryptSymmetrical(Bytes, Key)
   
   Call Form1.List3.AddItem(">> " & StrConv(Bytes, vbUnicode))
   
   ' Empfangen
   Call Dest.Receive(StrConv(Bytes, vbUnicode))
End Sub

' Ich empfange Text
Public Sub Receive(ByVal Cyphertext As String)
   Dim Bytes() As Byte
   
   Bytes = StrConv(Cyphertext, vbFromUnicode)
   
   ' Mit dem Schlssel entschlsseln
   Call EncryptSymmetrical(Bytes, Key)
   
   RaiseEvent GotMessage(StrConv(Bytes, vbUnicode))
End Sub
